#include "atnd.h"

namespace {
    char GAP[] = " ";
}

bool RingBuffer::reading(std::string & fileName) {
    using namespace std;

    bool neighborhood = false;
    bool written = false;
    int lineNumber = 0;
    int sum = 0;
    LINE_NUMBER_FUNCTION lineBegins = nonnumber;
    string *p = new string("");
    string line = EMPTY;
    prepareRing();

    ifstream sjisFile( fileName.c_str() );
    if( sjisFile.fail() ) {
        errorHandler("ifstream sjisFile() error:", fileName);
        return neighborhood;
    }

    if(number) {
        lineBegins = lineBeginsWithNumber;
    }

    if(after > 0) {
        int count = 0;
        while( sjisFile.getline(buffer, bufferSize) ) {
            p = lineBegins(p, buffer, combo);
            ring.pop_front();
            ring.push_back(*p);

            if(neighborhood) {
                count += 1;
                if(count >= after) {
                    showRing();
                    prepareRing();
                    written = true;
                    count = 0;
                    neighborhood = false;
                }

            }

            lineNumber += 1;
            if(lineNumber == point) {
                neighborhood = true;
                sum += 1;
            }

        }

        if(! sjisFile.eof() ) {
            if( sjisFile.fail() ) {
                cerr << "sjisFile.fail() error: " << bufferSize << " bytes" << endl;
                return neighborhood;
            }

        }

    } else {
        while( sjisFile.getline(buffer, bufferSize) ) {
            p = lineBegins(p, buffer, combo);
            ring.pop_front();
            ring.push_back(*p);

            lineNumber += 1;
            if(lineNumber == point) {
                neighborhood = true;
                sum += 1;
                showRing();
                prepareRing();
                written = true;
            }

        }

        if(! sjisFile.eof() ) {
            if( sjisFile.fail() ) {
                cerr << "sjisFile.fail() error: " << bufferSize << " bytes" << endl;
                return neighborhood;
            }

        }

    }

    if(neighborhood) {
        if(written) {
            ;
        } else {
            showRing();
            written = true;
        }

    } else {
        neighborhood = (sum > 0) ? true : false;
    }

    return neighborhood;
}

LINE_POINTER lineBeginsWithNumber(LINE_POINTER p, char *buffer, char *combo) {
    using namespace std;

    static int line_number;

    line_number += 1;
    sprintf(combo, "%10d|%s", line_number, buffer);
    delete p;
    p = new string(combo);
    return p;
}

LINE_POINTER nonnumber(LINE_POINTER p, char *buffer, char *combo) {
    using namespace std;

    delete p;
    p = new string(buffer);
    return p;
}

void errorHandler(const char *p, std::string & q) {
    using namespace std;

    ofstream errorFile(ERROR_TEXT);
    errorFile << p << GAP << q;
}

void RingBuffer::prepareRing() {
    using namespace std;

    ring.clear();
    for(int i = 0; i < ring_count; ++i) {
        ring.push_back(BELL);
    }

}

void RingBuffer::showRing() {
    using namespace std;

    string s;
    for(RING::iterator i = ring.begin(); i != ring.end(); ++i) {
        s = *i;
        if(s == BELL) {
            continue;
        } else {
            cout << s << endl;
        }

    }

}
