#ifndef ATND_H
#define ATND_H

#ifdef __BORLANDC__
#pragma warn -8004
#endif

#define VERSION 1.115
#define BUFFER_SIZE 524288 // 512 KB
#define COMMA ','
#define ERROR_TEXT "error.txt"
#define HE 0xCD // "" Shift_JIS
#include <deque>
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include "Line.h"
#include "Numbered.h"

typedef std::deque<std::string> RING;
typedef std::string* LINE_POINTER;
typedef LINE_POINTER (*LINE_NUMBER_FUNCTION)(LINE_POINTER p, char *buffer, char *combo);

class RingBuffer {
    const int ERROR_CODE;
    const std::string EMPTY;
    const std::string GAP;

    bool number;
    char *buffer;
    char *combo;
    int after, bufferSize, point, ring_count;
    RING ring;
    std::string BELL, fileName, newLine;

    void prepareRing();
    void showRing();

public:
    RingBuffer(int a, int before, int p, int b, bool n): BELL("\x07"), EMPTY(""), ERROR_CODE(1), GAP(" ") {
        after = a;
        point = p;
        ring_count = before + 1 + after;
        bufferSize = b;
        number = n;

        buffer = new char[bufferSize];
        combo = new char[bufferSize];
    }

    ~RingBuffer() {
        delete[] buffer;
        delete[] combo;
    }

    bool reading(std::string & fileName);
};

class Standard_input {
    const int ERROR_CODE;
    const std::string EMPTY;
    const std::string GAP;

    bool number;
    char *buffer;
    char *combo;
    int after, point, ring_count;
    RING ring;
    std::string BELL;

    void prepareRing();
    void showRing();

public:
    Standard_input(int a, int before, int p, bool n): BELL("\x07"), EMPTY(""), ERROR_CODE(1), GAP(" ") {
        after = a;
        point = p;
        ring_count = before + 1 + after;
        number = n;

        buffer = new char[BUFFER_SIZE];
        combo = new char[BUFFER_SIZE];
    }

    ~Standard_input() {
        delete[] buffer;
        delete[] combo;
    }

    bool standard_input_output();
};

class StandardInputLine {
    const std::string EMPTY;

    bool measure;
    char *buffer;
    int point;

public:
    StandardInputLine(int p, bool m): EMPTY("") {
        measure = m;
        point = p;
        buffer = new char[BUFFER_SIZE];
    }

    ~StandardInputLine() {
        delete[] buffer;
    }

    bool standard_input_output(std::string & label);
};

int punctuation(char *p, int q);
LINE_POINTER lineBeginsWithNumber(LINE_POINTER p, char *buffer, char *combo);
LINE_POINTER nonnumber(LINE_POINTER p, char *buffer, char *combo);
void errorHandler(const char *p, std::string & q);
void versionGuide(double v, bool comments);

#endif // ATND_H
