#include "atnd.h"

/*
atnd C++ Version 1.115
Displaying lines at and around the specified point (AT and arouND)
Copyright 2019 Sogaya

gcc (GCC) 3.4.2 (mingw-special)
Digital Mars C/C++ Compiler Version 8.57, STLport 4.5.3
Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    using namespace std;

    const bool LF_TO_LF_SPAN = true;
    const bool NO_MEASURING = false;
    const bool STOP = true;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int ERROR_CODE = 1;
    const int FIRST_LINE = 1;
    const int LABEL_SIZE = 2;
    const int NOT_CONVERTED = -1;
    const int NO_RING = 1;
    const int SEPARATOR_SIZE = 1;
    const int SEPARATOR_TERM_SIZE = 2;
    const string AFTER("-a");
    const string BEFORE("-b");
    const string CONTEXT("-c");
    const string EMPTY("");
    const string HEAD("-h");
    const string INTERVAL("-i");
    const string LABEL("-=");
    const string LINE_BUFFER_SIZE("-l");
    const string LF("-LF");
    const string NUMBER("-n");
    const string POINT("-p");
    const string SEPARATOR("-s");
    const string SIZE_OF_BUFFER("-z");
    const string STANDARD_INPUT("stdin");
    const string TAIL("-t");
    const string VERSION_WITHOUT_COMMENTS("-V");
    const string VERSION_WITH_COMMENTS("-VC");

    bool lineBeginsWithNumber = false;
    bool line_buffer_size = false;
    bool measure = NO_MEASURING;
    bool result = false;
    char MINUS_P1[] = "-p1";
    int after = 0;
    int before = 0;
    int buffer_size = BUFFER_SIZE;
    int exit_code = 0;
    int file_name_size = 0;
    int interval_0 = 0;
    int interval_1 = 1;
    int line_count;
    int maximum = 0;
    int q = 0;
    int point = FIRST_LINE;
    int ringCount = NO_RING;
    int separator = 0x0A;
    int tail = 0;
    Numbered *n = new Numbered(MINUS_P1);
    string *p = new string(MINUS_P1);
    string fileName = EMPTY;
    string label = STANDARD_INPUT;
    string argument;

    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(LF == argument) {
            measure = LF_TO_LF_SPAN;
            ringCount = NO_RING;
        } else if(LINE_BUFFER_SIZE == argument) {
            line_buffer_size = true;
        } else if(NUMBER == argument) {
            lineBeginsWithNumber = true;
        } else if(VERSION_WITH_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS);
        } else if(VERSION_WITHOUT_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argument.find(AFTER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                after = n->number();
                if( AFTER == n->parameter() ) {
                    if(after == NOT_CONVERTED) {
                        after = 0;
                    }

                    ringCount = before + 1 + after;
                    continue;
                }

                after = 0;
            }

            q = argument.find(BEFORE);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                before = n->number();
                if( BEFORE == n->parameter() ) {
                    if(before == NOT_CONVERTED) {
                        before = 0;
                    }

                    ringCount = before + 1 + after;
                    continue;
                }

                before = 0;
            }

            q = argument.find(CONTEXT);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                before = n->number();
                if( CONTEXT == n->parameter() ) {
                    if(before == NOT_CONVERTED) {
                        before = 0;
                    }

                    after = before;
                    ringCount = before + 1 + after;
                    continue;
                }

                before = 0;
            }

            q = argument.find(HEAD);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                point = n->number();
                if( HEAD == n->parameter() ) {
                    if(point == NOT_CONVERTED) {
                        point = FIRST_LINE;
                    }

                    after = 0;
                    before = point - 1;
                    ringCount = before + 1 + after;
                    continue;
                }

                point = FIRST_LINE;
            }

            q = argument.find(INTERVAL);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                interval_1 = n->number();
                if( n->trimmed_sequence() ) {
                    interval_0 = n->subnumber();
                    if( INTERVAL == n->parameter() ) {
                        if(interval_0 == NOT_CONVERTED) {
                            interval_0 = 0;
                            interval_1 = 1;
                        }

                        before = interval_1 - interval_0;
                        if(before >= 0) {
                            after = 0;
                            point = interval_1;
                            ringCount = before + 1 + after;
                            continue;
                        }

                        before = 0;
                    }

                }

                interval_0 = 0;
                interval_1 = 1;
            }

            q = argument.find(LABEL);
            if(q == 0) {
                q += LABEL_SIZE;
                label = argument.substr(q);
                continue;
            }

            q = argument.find(POINT);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                point = n->number();
                if( POINT == n->parameter() ) {
                    if(point == NOT_CONVERTED) {
                        point = FIRST_LINE;
                    }

                    continue;
                }

                point = FIRST_LINE;
            }

            q = argument.find(SEPARATOR);
            if(q == 0) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            q = argument.find(SIZE_OF_BUFFER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                buffer_size = n->number();
                if ( SIZE_OF_BUFFER == n->parameter() ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            q = argument.find(TAIL);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                tail = n->number();
                if( TAIL == n->parameter() ) {
                    if(tail == NOT_CONVERTED) {
                        tail = 0;
                    }

                    continue;
                }

                tail = 0;
            }

            fileName = argument;
        } // if

    } // for(int i = 1; i < argc; ++i)

    file_name_size = fileName.length();
    if(file_name_size == 0) {
        if(line_buffer_size) {
            cout << buffer_size << " bytes" << endl;
        }

        if(ringCount > 1) {
            Standard_input *i = new Standard_input(after, before, point, lineBeginsWithNumber);
            result = i->standard_input_output();
            delete i;
        } else {
            StandardInputLine *i = new StandardInputLine(point, measure);
            result = i->standard_input_output(label);
            delete i;
        }

        exit_code = result ? 0 : ERROR_CODE;
        delete n; delete p;
        return exit_code;
    }

    Line *e = new Line(fileName, point, measure);
    line_count = e->checkLineCount(STOP);

    if(tail > 1) {
        point = line_count;
        before = tail - 1;
        after = 0;
        ringCount = before + 1 + after;
    }

    if(buffer_size == BUFFER_SIZE) {
        maximum = e->maximumLineSize();
        buffer_size = maximum + SEPARATOR_SIZE;
        if(lineBeginsWithNumber) {
            buffer_size += FINAL_SIZE_1;
        }

    }

    if(line_buffer_size) {
        cout << buffer_size << " bytes" << endl;
    }

    if(ringCount > 1) {
        RingBuffer *r = new RingBuffer(after, before, point, buffer_size, lineBeginsWithNumber);
        result = r->reading(fileName);
        delete r;
    } else {
        if(separator == 0x0A) {
            result = e->reading();
        } else {
            result = e->reading(separator);
        }

    }

    exit_code = result ? 0 : ERROR_CODE;
    delete e; delete n; delete p;
    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: // 0xCD
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
