#include "Line.h"

bool Line::reading() {
    using namespace std;

    bool b = false;
    int n = 0;
    string *p = new string("");
    string line = EMPTY;
    ifstream sjisFile( fileName.c_str() );

    while( sjisFile.getline(buffer, bufferSize) ) {
        delete p;
        p = new string(buffer);
        line = *p;

        n += 1;
        if(n == point) {
            b = true;
            break;
        }

    }

    if(measure) {
        cout << fileName << ": " << lineCount;
        if(lineCount == 1) {
            cout << " line";
        } else {
            cout << " lines" << endl;
        }

        cout << "maximum LF-to-LF span of " << maximumLineLength << " bytes (line-" << lineNumber << ")" << endl;
    }

    cout << line << endl;
    delete p;
    return b;
}

bool Line::reading(int separator) {
    using namespace std;

    bool b = false;
    int fieldCount, fieldLength;
    int n = 0;
    string *p = new string("");
    string line = EMPTY;
    ifstream sjisFile( fileName.c_str() );

    while( sjisFile.getline(buffer, bufferSize) ) {
        delete p;
        p = new string(buffer);
        line = *p;

        n += 1;
        if(n == point) {
            b = true;
            break;
        }

    }

    if(measure) {
        cout << fileName << ": " << lineCount;
        if(lineCount == 1) {
            cout << " line";
        } else {
            cout << " lines" << endl;
        }

        fieldLength = maximumSpan(&fieldCount, separator, line.length() );
        fieldLength -= SEPARATOR_SIZE;
        cout << "maximum separator-to-separator span of " << fieldLength << " bytes (line-" << point << ")" << endl;
    }

    cout << line << endl;
    delete p;
    return b;
}

int Line::maximumSpan() {
    int c, m;
    int count = 0;
    int k;
    int max = 0;
    int trace = NOT_FOUND;
    unsigned char uc;

    carriageReturn = false;
    newLineLength = 1;
    for(k = 0; k < bufferSize && trace == NOT_FOUND; ++k) {
        uc = (unsigned char)buffer[k];
        c = (int)uc;

        switch(c) {
        case 0x0A:
            count += 1;

            if(carriageReturn) {
                max = k - 1 + newLineLength;
            } else {
                max = k + newLineLength;
            }

            lineNumber = count;
            trace = k; // trace != NOT_FOUND
            break;
        case 0x0D:
            carriageReturn = true;
            newLineLength = 2;
            break;
        default:
            break;
        }

    }

    for( ; k < bufferSize; ++k) {
        uc = (unsigned char)buffer[k];
        c = (int)uc;

        switch(c) {
        case 0x0A:
            count += 1;
            m = k - trace;
            if(m > max) {
                max = m;
                lineNumber = count;
            }

            trace = k;
            break;
        default:
            break;
        }

    }

    lineCount = count;
    return max;
}

int Line::maximumSpan(int *p, int separator, int size) {
    int c, m;
    int count = 0;
    int k;
    int max = 0;
    int trace = NOT_FOUND;
    unsigned char uc;

    for(k = 0; k < size; ++k) {
        uc = (unsigned char)buffer[k];
        c = (int)uc;

        if(c == separator) {
            count += 1;
            max = k + SEPARATOR_SIZE;
            trace = k;
            break;
        }

    }

    for( ; k < size; ++k) {
        uc = (unsigned char)buffer[k];
        c = (int)uc;

        if(c == separator) {
            count += 1;
            m = k - trace;
            if(m > max) {
                max = m;
            }

            trace = k;
        }

    }

    *p = count;
    return max;
}

