#include "hanzen.h"

extern int ascii;
SparseKana *kana;
KANJI kanji_union;
KANJI *double_byte_character = &kanji_union;

namespace {
    const int HA_HI_HU_HE_HO = 15;
    const int KA_SA_TA_HA_SIZE = 20;
}

bool seion(int beginning, char first_byte, char second_byte) {
    bool b = false;
    char d[2] = {0, 0};
    int ka_sa_ta_ha[20] = {0x834A, 0x834C, 0x834E, 0x8350, 0x8352, 0x8354, 0x8356, 0x8358, 0x835A, 0x835C, 0x835E, 0x8360, 0x8363, 0x8365, 0x8367, 0x836E, 0x8371, 0x8374, 0x8377, 0x837A};
    int test;

    d[0] = first_byte;
    d[1] = second_byte;
    test = inverted(d);

    for(int i = beginning; i < KA_SA_TA_HA_SIZE; ++i) {
        if(ka_sa_ta_ha[i] == test) {
            b = true;
            break;
        }

    }

    return b;
}

int inverted(char *c) {
    char *p = (char *)double_byte_character->sequence;

// Copying in reverse order
    p[0] = c[1];
    p[1] = c[0];
    return double_byte_character->code[0];
}

FIELD_POINTER abolish_hankaku(FIELD_POINTER p) {
    bool kanji = false;
    int c = 0x40;
    int k = 0;
    int SIZE_1 = kana->kanaBufferSize() - 1;
    unsigned char uc;
    unsigned char firstByte = 0x40;

    kana->buffer[SIZE_1] = '\0';
    strncpy(kana->buffer, p,  SIZE_1);

    for(int i = 0; kana->buffer[i]; ++i) {
        uc = (unsigned char) kana->buffer[i];
        c = (int)uc;

        if(kanji) {
            kana->combo[k] = firstByte;
            kana->combo[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = false;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c < KANA_DAKUTEN) {
                kana->combo[k] = ascii;
                k += KATAKANA_SIZE;
            } else if (c == KANA_DAKUTEN) {
                continue; // skipping a combining character
            } else if (c == KANA_HANDAKUTEN) {
                continue; // skipping a combining character
            } else {
                firstByte = uc;
                kanji = true;
            }

        } else {
            kana->combo[k++] = (char)uc;
        }

    } // for(int i = 0; kana->buffer[i]; ++i)

    kana->combo[k] = '\0';
    p = & kana->combo[0];
    return p;
}

FIELD_POINTER hankaku_zenkaku(FIELD_POINTER p) {
    bool kanji = false;
    int c = 0x40;
    int k = 0;
    int previous = 0xB6;
    int SIZE_1 = kana->kanaBufferSize() - 1;
    unsigned char uc;
    unsigned char firstByte = 0x40;

    kana->buffer[SIZE_1] = '\0';
    strncpy(kana->buffer, p,  SIZE_1);

    for(int i = 0; kana->buffer[i]; ++i) {
        uc = (unsigned char) kana->buffer[i];
        c = (int)uc;

        if(kanji) {
            kana->combo[k] = firstByte;
            kana->combo[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = false;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c < KANA_DAKUTEN) {
                kana->combo[k] = kana->working(c, 0);
                kana->combo[ k + 1 ] = kana->working(c, 1);
                k += ZENKAKU_SIZE;
                previous = c;
            } else if (c == KANA_DAKUTEN) {
                // combining character
                k -= ZENKAKU_SIZE;

                if( seion(0, kana->combo[k], kana->combo[k + 1]) ) {
                    kana->combo[k] = kana->dakuten(previous, 0);
                    kana->combo[ k + 1 ] = kana->dakuten(previous, 1);
                    k += ZENKAKU_SIZE;
                } else {
                    k += ZENKAKU_SIZE;
                }

            } else if (c == KANA_HANDAKUTEN) {
                // combining character
                k -= ZENKAKU_SIZE;

                if ( seion(HA_HI_HU_HE_HO, kana->combo[k], kana->combo[k + 1]) ) {
                    kana->combo[k] = kana->handakuten(previous, 0);
                    kana->combo[ k + 1 ] = kana->handakuten(previous, 1);
                    k += ZENKAKU_SIZE;
                } else {
                    k += ZENKAKU_SIZE;
                }

            } else {
                firstByte = uc;
                kanji = true;
            }

        } else {
            kana->combo[k++] = (char)uc;
        }

    } // for(int i = 0; kana->buffer[i]; ++i)

    kana->combo[k] = '\0';
    p = & kana->combo[0];
    return p;
}

FIELD_POINTER replace_hankaku_with_zenkaku_except_dakuten(FIELD_POINTER p) {
    bool kanji = false;
    int c = 0x40;
    int k = 0;
    int SIZE_1 = kana->kanaBufferSize() - 1;
    unsigned char uc;
    unsigned char firstByte = 0x40;

    kana->buffer[SIZE_1] = '\0';
    strncpy(kana->buffer, p,  SIZE_1);

    for(int i = 0; kana->buffer[i]; ++i) {
        uc = (unsigned char) kana->buffer[i];
        c = (int)uc;

        if(kanji) {
            kana->combo[k] = firstByte;
            kana->combo[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = false;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c < KANA_DAKUTEN) {
                kana->combo[k] = kana->working(c, 0);
                kana->combo[ k + 1 ] = kana->working(c, 1);
                k += ZENKAKU_SIZE;
            } else if (c == KANA_DAKUTEN) {
                continue; // skipping a combining character
            } else if (c == KANA_HANDAKUTEN) {
                continue; // skipping a combining character
            } else {
                firstByte = uc;
                kanji = true;
            }

        } else {
            kana->combo[k++] = (char)uc;
        }

    } // for(int i = 0; kana->buffer[i]; ++i)

    kana->combo[k] = '\0';
    p = & kana->combo[0];
    return p;
}

FIELD_POINTER transparent(FIELD_POINTER p) {
    return p;
}

