#include "narfi.h"

namespace {
    bool LISTED = true;
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int NEW_NAME_ERROR = 2;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
    char GAP[] = " ";
}

DestroyRebuild::DestroyRebuild(char *e, char *b, char *n, long z, int s, int f, bool r, bool w) {
    using namespace std;

    int phase = BUFFER;

    strcpy(file_name, e);
    strcpy(new_name, n);
    buffer_size = (int)z;
    field_count = f;
    remove_separators = r;
    separator = s;
    way_of_arranging = w;

    pattern[FIELD_COUNT] = '\0';
    strncpy(pattern, b, FIELD_COUNT);

    char *p = strchr(pattern, CLEAR);
    full_house = (p == NULL) ? true : false;

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];
    } catch(...) {
        cerr << "new char[] error-7: " << buffer_size << " bytes ( phase = " << phase << " )" << endl;
        exit(1);
    }

}

int DestroyRebuild::selecting() {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    FILE *file;
    long z = (long)buffer_size;
    int exit_code = 0;
    ofstream new_file(new_name);
    if( new_file.fail() ) {
        exit_code = NEW_NAME_ERROR;
        errorHandler("ofstream new_file() error:", new_name);
        exit(1);
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        cerr << "fopen() error-2: " << file_name  << endl;
        return ERROR_CODE;
    }

    if(way_of_arranging) {
//        full_house = true;

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Dividing(z, separator, few_fields, remove_separators);
                new_file << d->reverse_unite(buffer) << endl;
            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Dividing(z, separator, field_count, remove_separators);
                new_file << d->reverse_unite(buffer) << endl;
            }

        }

    } else {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Dividing(z, separator, few_fields, remove_separators);
                    new_file << d->unite(buffer) << endl;
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    delete d;
                    d = new Dividing(pattern, z, separator, few_fields, remove_separators);
                    new_file << d->unite(buffer) << endl;
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                delete d;
                d = new Dividing(pattern, z, separator, field_count, remove_separators);
                new_file << d->unite(buffer) << endl;
            }

        }

    }

    fclose(file);
    delete d;
    return exit_code;
}

int DestroyRebuild::selecting(int field_number, int editing) {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    EDIT_FUNCTION extracting = extract_decimal;
    FILE *file;
    int exit_code = 0;
    long z = (long)buffer_size;
    ofstream new_file(new_name);
    if( new_file.fail() ) {
        exit_code = NEW_NAME_ERROR;
        errorHandler("ofstream new_file() error:", new_name);
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        cerr << "fopen() error-3: " << file_name  << endl;
        return ERROR_CODE;
    }

    switch(editing) {
    case NEITHER_EXTRACT_NOR_REMOVE:
        extracting = transparent;
        break;
    case EXTRACT_DECIMAL_FROM_FIELD:
//        extracting = extract_decimal;
        break;
    case EXTRACT_INTEGER_FROM_FIELD:
        extracting = extract_integer;
        break;
    case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
        extracting = remove_control;
        break;
    case REPLACE_KATAKANA_WITH_ASCII:
        extracting = skip_control_characters_to_abolish_hankaku;
        break;
    default:
        extracting = extract_decimal;
        break;
    }

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, few_fields, remove_separators);
            d->editing_fields_list(buffer, extracting, field_number);
            new_file << d->unite(buffer, LISTED) << endl;
        }

    } else {
        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, field_count, remove_separators);
            d->editing_fields_list(buffer, extracting, field_number);
            new_file << d->unite(buffer, LISTED) << endl;
        }

    }

    fclose(file);
    delete d;
    return exit_code;
}

void detach_buffers(KANA_ASCII *kana) {
    free(kana->buffer);
    free(kana->combo);
}

void errorHandler(const char *p, char *q) {
    using namespace std;

    ofstream errorFile(ERROR_TEXT);
    errorFile << p << GAP << q;
}

void errorHandler(const char *p, const char *q) {
    using namespace std;

    ofstream errorFile(ERROR_TEXT);
    errorFile << p << GAP << q;
}
