#include "narfi.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    cerr << "narfi C++ Version " << v << "\n" << endl;

    if(comments) {
        cerr << "narfi -c4 wide             # Produce narfi.txt that has 4 fields. " << endl
            << "narfi -c4 wide narrow      # Produce a narrow file that has 4 fields. " << endl
            << "narfi -c4 < wide > narrow  # Produce a narrow file that has 4 fields. " << endl
            << "narfi -c4 -b1011 wide      # narfi.txt has Field-1, Field-3 and Field-4. " << endl
            << "narfi -c4 -e2 wide         # Extract a decimal from Field-2. " << endl
            << "narfi -c4 -i2-3 wide       # narfi.txt has Field-2 and Field-3. " << endl
            << "narfi -c4 -k2 -a_ wide     # In Field-2, narfi replaces katakana with ascii." << endl
            << "narfi -c4 -l wide          # Show how large the buffer is. " << endl
            << "narfi -c4 -n2 wide         # Extract an integer from Field-2. " << endl
            << "narfi -c4 -o2 wide         # Remove control characters from Field-2. " << endl
            << "narfi -c4 -q wide          # Commas disappear if placed in quotes. " << endl
            << "narfi -c4 -r wide          # Arrange fields in reverse order. " << endl
            << "narfi -c4 -s, wide         # CSV " << endl
            << "narfi -c4 -s\\l wide        # Wiki table " << endl
            << "narfi -c4 -s\\l -x- csv     # Do not check if the file name includes .csv " << endl
            << "narfi -c4 -s\\x7C wide      # Wiki table " << endl
            << "narfi -c4 -z256 wide       # Use a buffer of 256 bytes. " << endl
            << "narfi -c255 -f wide        # Check if all lines share the field count. " << endl
            << "narfi -V                   # version " << endl
            << "narfi -VC                  # version with comments " << endl;
    } else {
        cerr << "narfi -c4 wide             " << endl
            << "narfi -c4 wide narrow      " << endl
            << "narfi -c4 < wide > narrow  " << endl
            << "narfi -c4 -b1011 wide      " << endl
            << "narfi -c4 -e2 wide         " << endl
            << "narfi -c4 -i2-3 wide       " << endl
            << "narfi -c4 -k2 -a_ wide     " << endl
            << "narfi -c4 -l wide          " << endl
            << "narfi -c4 -n2 wide         " << endl
            << "narfi -c4 -o2 wide         " << endl
            << "narfi -c4 -q wide          " << endl
            << "narfi -c4 -r wide          " << endl
            << "narfi -c4 -s, wide         " << endl
            << "narfi -c4 -s\\l wide        " << endl
            << "narfi -c4 -s\\l -x- csv     " << endl
            << "narfi -c4 -s\\x7C wide      " << endl
            << "narfi -c4 -z256 wide       " << endl
            << "narfi -c255 -f wide        " << endl
            << "narfi -V                   " << endl
            << "narfi -VC                  " << endl;
    }

    exit(1);
}
