#include "narfi.h"

namespace {
    bool LISTED = true;
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int NEW_NAME_ERROR = 2;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
    char GAP[] = " ";
}

int DestroyRebuild::counting() {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    FILE *file;
    long z = (long)buffer_size;
    int exit_code = 0;
    int f, shared_field_count;

    file = fopen(file_name, "rt");
    if(file == NULL) {
        cerr << "fopen() error-2: " << file_name  << endl;
        return ERROR_CODE;
    }

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Dividing(z, separator, few_fields, remove_separators);
        shared_field_count = d->mapping_fields_list(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, few_fields, remove_separators);
            f = d->mapping_fields_list(buffer);
            if(f != shared_field_count) {
                cout << d->unite(buffer, LISTED) << endl;
            }

        }

    } else {
        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Dividing(pattern, z, separator, field_count, remove_separators);
        shared_field_count = d->mapping_fields_list(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(pattern, z, separator, field_count, remove_separators);
            f = d->mapping_fields_list(buffer);
            if(f != shared_field_count) {
                cout << d->unite(buffer, LISTED) << endl;
            }

        }

    }

    fclose(file);
    delete d;
    return exit_code;
}

int Standard_input::standard_input_counting() {
    using namespace std;

    char *p;
    char few_fields;
    Dividing *d = new Dividing(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    int exit_code = 0;
    int f, shared_field_count;
    long z = (long)buffer_size;

    if(field_count <= 0x00FF) { // 0 to 255
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Dividing(z, separator, few_fields, remove_separators);
        shared_field_count = d->mapping_fields_list(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(z, separator, few_fields, remove_separators);
            f = d->mapping_fields_list(buffer);
            if(f != shared_field_count) {
                cout << d->unite(buffer, LISTED) << endl;
            }

        }

    } else {
        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            return ERROR_CODE;
        }

        delete d;
        d = new Dividing(pattern, z, separator, field_count, remove_separators);
        shared_field_count = d->mapping_fields_list(buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            delete d;
            d = new Dividing(pattern, z, separator, field_count, remove_separators);
            f = d->mapping_fields_list(buffer);
            if(f != shared_field_count) {
                cout << d->unite(buffer, LISTED) << endl;
            }

        }

    }

    delete d;
    return exit_code;
}

