#ifndef NARFI_H
#define NARFI_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif

#define VERSION 1.16
#define ASCII_SIZE 1
#define BELL 0x07
#define BELL_ASCII_KATAKANA_COUNT 224
#define BUFFER_SIZE 524288 // 512 KB
#define COMMA ','
#define DECIMAL_FIELD_SIZE 512
#define ERROR_TEXT "error.txt"
#define FIELD_COUNT 3072
#define HE 0xCD // "" Shift_JIS
#define KANA_DAKUTEN 0xDE
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KATAKANA_SIZE 1
#define NARFI_TEXT "narfi.txt"
#define ZENKAKU_SIZE 2
#define ZENKAKU_SIZE_1 3
#include "Dividing.h"
#include "Line.h"
#include "Numbered.h"

enum EDITING_METHOD {
    NEITHER_EXTRACT_NOR_REMOVE,
    EXTRACT_DECIMAL_FROM_FIELD,
    EXTRACT_INTEGER_FROM_FIELD,
    REMOVE_CONTROL_CHARACTERS_FROM_FIELD,
    REPLACE_KATAKANA_WITH_ASCII,
    METHOD_COUNT
};

typedef struct KANA_ASCII KANA_ASCII;
struct KANA_ASCII {
    char *buffer;
    char *combo;
    int ascii, buffer_size;
};

class DestroyRebuild {
//protected:
    bool full_house, remove_separators, way_of_arranging;
    char *buffer;
    char *combo;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char new_name[ FILE_NAME_SIZE + 1 ];
    char pattern[ FIELD_COUNT + 1 ];
    int buffer_size, field_count, separator;

public:
//    virtual
    ~DestroyRebuild() {
        delete[] buffer;
        delete[] combo;
    }

    DestroyRebuild(char *e, char *b, char *n, long z, int s, int f, bool r, bool w);
    int counting();
    int selecting();
    int selecting(int field_number, int editing);
};

class Standard_input {
    bool full_house, remove_separators, way_of_arranging;
    char *buffer;
    char *combo;
    char pattern[ FIELD_COUNT + 1 ];
    int buffer_size, field_count, separator;

public:
    ~Standard_input() {
        delete[] buffer;
        delete[] combo;
    }

    Standard_input(char *b, long z, int s, int f, bool r, bool w);
    int standard_input_counting();
    int standard_input_output();
    int standard_input_output(int field_number, int editing);
};

bool extensionEqualsCSV(std::string & name);
bool setting(KANA_ASCII *kana, long z, int ascii);
FIELD_POINTER extract_decimal(FIELD_POINTER p);
FIELD_POINTER extract_integer(FIELD_POINTER p);
FIELD_POINTER remove_control(FIELD_POINTER p);
FIELD_POINTER skip_control_characters_to_abolish_hankaku(FIELD_POINTER p);
FIELD_POINTER transparent(FIELD_POINTER p);
int punctuation(char *p, int q);
void detach_buffers(KANA_ASCII *kana);
void errorHandler(const char *p, char *q);
void errorHandler(const char *p, const char *q);
void versionGuide(double v, bool comments);

#endif // NARFI_H
