#include "obot.h"

namespace {
    char GAP[] = " ";
}

int Represented_in_hexadecimal::run() {
    using namespace std;

    char field[4] = {0, 0, 0, 0};
    int exit_code = 0;
    int k = 0;
    int n;
    unsigned char uc;
    ifstream binaryFile( fileName.c_str(), ios::in | ios::binary);
    if( binaryFile.fail() ) {
        return ERROR_CODE;
    }

    binaryFile.read(buffer, bufferSize);
    while(k < bufferSize) {
        for(int i = 0; i < fieldCount; ++i) {
            uc = (unsigned char)buffer[k++];
            n = (int)uc;
            sprintf(field, "%02X%c", n, separator);
            cout << field;

            if(uc == 0x0A) {
                lineCount += 1;
                if(lineCount >= limit) {
                    k = bufferSize;
                }

            }

            if(k >= bufferSize) {
                break;
            }

        }

        cout << endl;
        rowNumber += 1;
        if(rowNumber > maximumRowNumber) {
            break;
        }

    }

    return exit_code;
}

/*
1: obot.exe       file
2: 640            buffer
3: 3              lines
4: 20h            separator
5: 20             fields
6: 2147483647     rows
*/

void acquire_parameters_from_text(const char *parameters_text, char *file_name, int *buffer_size, int *limit, int *separator, int *field_count, int *maximum_row_number) {
    const int HEXADECIMAL_NUMBER = 16;

    char *p;
    char *stop;
    char c[C_SIZE];
    FILE *setting = fopen(parameters_text, "rt");
    int k;
    int line_number = 0;

    if(setting != NULL) {
        for(;;) {
            p = fgets(c, C_SIZE, setting);
            if(p == NULL) {
                break;
            } else {
                k = strcspn(c, "\n',|\t");
                c[k] = '\0';
            }

            line_number += 1;
            switch(line_number) {
            case 1:
                strcpy(file_name, c); // a binary or text file
                break;
            case 2:
                *buffer_size = (int)strtol(c, &stop, 10); // 640 bytes
                break;
            case 3:
                *limit = (int)strtol(c, &stop, 10); // 3 lines of the text file
                break;
            case 4:
                *separator = (int)strtol(c, &stop, HEXADECIMAL_NUMBER); // 20h
                break;
            case 5:
                *field_count = (int)strtol(c, &stop, 10); // The table has 20 fields or less.
                break;
            case 6:
                *maximum_row_number = (int)strtol(c, &stop, 10); // The table has 2147483647 rows or less.
                break;
            default:
                break;
            } // switch(line_number)

        } // for(;;)

        fclose(setting);
    } // if(setting != NULL)

}

void errorHandler(const char *p, const char *q) {
    using namespace std;

    ofstream errorFile(ERROR_TEXT);
    errorFile << p << GAP << q;
}

void errorHandler(const char *p, std::string & q) {
    using namespace std;

    ofstream errorFile(ERROR_TEXT);
    errorFile << p << GAP << q;
}
