#ifndef OBOT_H
#define OBOT_H

#ifdef __BORLANDC__
#pragma warn -8004
#endif

#define VERSION 1.05
#define COMMA ','
#define C_SIZE 256 // FILE_NAME_SIZE + 1
#define FIELD_COUNT 20
#define FILE_NAME_SIZE 255
#define END_OF_FILE 2
#define ERROR_TEXT "error.txt"
#define FILE_ERROR -1L
#define HE 0xCD // "" Shift_JIS
#define SETTING_TEXT "set_obot.txt"
#include <cstdio> // sprintf()
#include <fstream>
#include <iostream>
#include <sstream>
#include <stdlib.h>
#include <string>
#include "Numbered.h"

int punctuation(char *p, int q);
void acquire_parameters_from_text(const char *parameters_text, char *file_name, int *buffer_size, int *limit, int *separator, int *field_count, int *maximum_row_number);
void errorHandler(const char *p, const char *q);
void errorHandler(const char *p, std::string & q);
void versionGuide(double v, bool comments);

class Represented_in_hexadecimal {
    const int ERROR_CODE;
    const int FIELD_SIZE;
    const std::string EMPTY;

    char *buffer;
    int bufferSize, fieldCount, limit, lineCount, maximumRowNumber, rowNumber, separator, size;
    long file_size;
    std::string fileName;

public:
    bool fileError() const {
        return (file_size == FILE_ERROR) ? true : false;
    }

    long fileSize() {
        long size = FILE_ERROR;
        FILE *p = fopen( fileName.c_str(), "rb");
        if(p == NULL) {
            errorHandler("fopen() error:", fileName);
            return size;
        }

        fseek(p, 0, END_OF_FILE);
        size = ftell(p);
        if( size < 0L ) {
            errorHandler("ftell() error:", fileName);
        }

        fclose(p);
        return size;
    }

    Represented_in_hexadecimal(char *p, int b, int f, int l, int m, int s): ERROR_CODE(1), FIELD_SIZE(3), EMPTY("") {
        std::string e(p);

        fileName = e;
        bufferSize = b;
        fieldCount = f;
        limit = l;
        lineCount = 0;
        maximumRowNumber = m;
        rowNumber = 1;
        separator = s;

        file_size = fileSize();
        if(file_size == FILE_ERROR) {
            buffer = NULL;
        } else {
            size = (int)file_size;
            if(bufferSize > size) {
                bufferSize = size;
            }

            buffer = new char[bufferSize];
        }

    }

    ~Represented_in_hexadecimal() {
        delete[] buffer;
    }

    int run();
};

#endif // OBOT_H
