#include "obot.h"

/*
obot C++ Version 1.05
Copyright 2019 Sogaya
Reading and writing so that the first part of EXE can be represented in hexadecimal as 4D 5A, for example.

gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    using namespace std;

    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int BUFFER_SIZE = 640;
    const int ERROR_CODE = 1;
    const int GAP = ' ';
    const int NOT_CONVERTED = -1;
    const int NOT_FOUND = -1;
    const int SEPARATOR_TERM_SIZE = 2;
    const int UPPER_LIMIT = 3;
    const string FIELD_COUNT_TERM("-c");
    const string LINES_OF_FILE("-m");
    const string READ_BUFFER("-b");
    const string ROWS_OF_TABLE("-r");
    const string SEPARATOR("-s");
    const string VERSION_WITHOUT_COMMENTS("-V");
    const string VERSION_WITH_COMMENTS("-VC");

    char MINUS_M3[] = "-m3";
    char file_name[ FILE_NAME_SIZE + 1 ];
    int buffer_size = BUFFER_SIZE;
    int exit_code = 0;
    int field_count = FIELD_COUNT;
    int limit = UPPER_LIMIT;
    int q = NOT_FOUND;
    int maximum_row_number = FINAL;
    int separator = GAP;
    Numbered *n = new Numbered(MINUS_M3);
    string *p = new string("");
    strcpy(file_name, "obot.exe");
    string argument;

// Acquiring parameters from SETTING_TEXT unless the user removes it.
    acquire_parameters_from_text(SETTING_TEXT, file_name, &buffer_size, &limit, &separator, &field_count, &maximum_row_number);

    string fileName(file_name);
    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(VERSION_WITH_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS);
        } else if(VERSION_WITHOUT_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argument.find(FIELD_COUNT_TERM);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                field_count = n->number();
                if ( FIELD_COUNT_TERM == n->parameter() ) {
                    if(field_count == NOT_CONVERTED) {
                        field_count = FIELD_COUNT;
                    }

                    continue;
                }

                field_count = FIELD_COUNT;
            }

            q = argument.find(LINES_OF_FILE);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                limit = n->number();
                if( LINES_OF_FILE == n->parameter() ) {
                    if(limit == NOT_CONVERTED) {
                        limit = UPPER_LIMIT;
                    }

                    continue;
                }

                limit = UPPER_LIMIT;
            }

            q = argument.find(READ_BUFFER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                buffer_size = n->number();
                if( READ_BUFFER == n->parameter() ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            q = argument.find(ROWS_OF_TABLE);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                maximum_row_number = n->number();
                if( ROWS_OF_TABLE == n->parameter() ) {
                    if(buffer_size == NOT_CONVERTED) {
                        maximum_row_number = FINAL;
                    }

                    continue;
                }

                maximum_row_number = FINAL;
            }

            q = argument.find(SEPARATOR);
            if(q == 0) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            fileName = argument;
        } // else {

    } // for(int i = 1; i < argc; ++i)

    file_name[FILE_NAME_SIZE] = '\0';
    strncpy(file_name, fileName.c_str(), FILE_NAME_SIZE);
    Represented_in_hexadecimal *obot = new Represented_in_hexadecimal(file_name, buffer_size, field_count, limit, maximum_row_number, separator);
    if( obot->fileError() ) {
        cerr << "file error: " << file_name << endl;
        return ERROR_CODE;
    }

    exit_code = obot->run();

    delete n;
    delete obot;
    delete p;
    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: // 0xCD
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
