#include "segmented.h"

bool STOP = true;

static bool full_house[256] = {
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true
};

bool Segmented::attempt_to_provide_buffers(bool stop) {
    using namespace std;

    bool vain = false;
    int phase = BUFFER;

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];

        phase = SELECTED;
        selected = new bool[ sizeof(bool) * ( field_count + 1 ) ];
        allocated = true;

    } catch(...) {
        stringstream os;
        os << "new char[] error-2: buffer_size = " << buffer_size << "( phase = " << phase << " )";
        messages = os.str();
        vain = true;

        if(stop) {
            cerr << messages << endl;
            exit(1);
        }

    }

    return vain;
}

bool Segmented::full_house_attempt_to_provide_buffers(bool stop) {
    using namespace std;

    bool vain = false;
    int phase = BUFFER;

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];

        selected = full_house;
        allocated = false;

    } catch(...) {
        stringstream os;
        os << "new char[] error-3: buffer_size = " << buffer_size << "( phase = " << phase << " )";
        messages = os.str();
        vain = true;

        if(stop) {
            cerr << messages << endl;
            exit(1);
        }

    }

    return vain;
}

int Segmented::search_separator(char *p, int beginning) {
    bool no_splitting = false;
    int n;
    int s = NOT_RECOGNIZED;
    unsigned char uc;

    buffer[ buffer_size - 1 ] = '\0';
    strncpy(buffer, p, buffer_size - 1 );

    for(int k = beginning; buffer[k]; ++k) {
        uc = (unsigned char)buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == quote) {
                no_splitting = false;
            }

            continue; // Commas disappear if placed in quotes.
        }

// splitting
        if(n == quote) {
            no_splitting = true;
        } else if(n == separator) {
            s = k;
            break;
        }

    }

    return s;
}

int Segmented::segmented_summary(char *p) {
    using namespace std;

    bool no_splitting = false;
    char *q;
    int field_number = 1;
    int n;
    int m = 0;
    unsigned char uc;

    buffer[ buffer_size - 1 ] = '\0';
    strncpy(buffer, p, buffer_size - 1 );

    q = strchr(buffer, '\n');
    if(q == NULL) {
        if(buffer_size != UNBROKEN_BUFFER_SIZE) {
            stringstream os;
            os << "0Ah is not included in a buffer of " << buffer_size << " bytes.";
            messages = os.str();
            cerr << messages << endl;
            exit(1);
        }

    } else {
        *q = '\0';
    }

    for(int k = 0; buffer[k]; ++k) {
        uc = (unsigned char)buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == quote) {
                no_splitting = false;
                if(selected[field_number]) {
                    combo[m++] = buffer[k];
                }

            } else if(n == separator) {
                if(remove_separators) {
                    continue;
                } else {
                    if(selected[field_number]) {
                        combo[m++] = buffer[k];
                    }

                }

            } else {
                if(selected[field_number]) {
                    combo[m++] = buffer[k];
                }

            }

            continue;
        }

// splitting
        if(n == quote) {
            no_splitting = true;
            if(selected[field_number]) {
                combo[m++] = buffer[k];
            }

        } else if(n == separator) {
            if(selected[field_number]) {
                combo[m++] = joint;
            }

            field_number += 1;
            if(field_number > field_count) {
                break;
            }

        } else {
            if(selected[field_number]) {
                combo[m++] = buffer[k];
            }

        }

    }

    combo[m] = '\0';
    if(combo[ m - 1 ] == joint) {
        field_number -= 1;
    }

    field_count = field_number;
    return field_number;
}

int Segmented::segmented_summary(char *p, int d, int h) {
    using namespace std;

    bool no_splitting = false;
    char *q;
    int field_number = 1;
    int n;
    int m = 0;
    unsigned char uc;

    buffer[ buffer_size - 1 ] = '\0';
    strncpy(buffer, p, buffer_size - 1 );

    q = strchr(buffer, '\n');
    if(q == NULL) {
        if(buffer_size != UNBROKEN_BUFFER_SIZE) {
            stringstream os;
            os << "0Ah is not included in a buffer of " << buffer_size << " bytes.";
            messages = os.str();
            cerr << messages << endl;
            exit(1);
        }

    } else {
        *q = '\0';
    }

    dakuten = d;
    handakuten = h;
    for(int k = 0; buffer[k]; ++k) {
        uc = (unsigned char)buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == quote) {
                no_splitting = false;
                if(selected[field_number]) {
                    combo[m++] = buffer[k];
                }

            } else if(n == dakuten) {
                continue;
            } else if(n == handakuten) {
                continue;
            } else if(n == separator) {
                if(remove_separators) {
                    continue;
                } else {
                    if(selected[field_number]) {
                        combo[m++] = buffer[k];
                    }

                }

            } else {
                if(selected[field_number]) {
                    combo[m++] = buffer[k];
                }

            }

            continue;
        }

// splitting
        if(n == quote) {
            no_splitting = true;
            if(selected[field_number]) {
                combo[m++] = buffer[k];
            }

        } else if(n == dakuten) {
            continue;
        } else if(n == handakuten) {
            continue;
        } else if(n == separator) {
            if(selected[field_number]) {
                combo[m++] = joint;
            }

            field_number += 1;
            if(field_number > field_count) {
                break;
            }

        } else {
            if(selected[field_number]) {
                combo[m++] = buffer[k];
            }

        }

    }

    combo[m] = '\0';
    if(combo[ m - 1 ] == joint) {
        field_number -= 1;
    }

    field_count = field_number;
    return field_number;
}

Segmented::Segmented(int s) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    field_count = FIELD_COUNT;
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(int s, bool r) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    field_count = FIELD_COUNT;
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(int s, char f) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = false;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Segmented::Segmented(int s, char f, bool r) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = r;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Segmented::Segmented(int s, int f) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(int s, int f, bool r) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(long z, int s) {
    buffer_size = (int)z;
    field_count = FIELD_COUNT;
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(long z, int s, bool r) {
    buffer_size = (int)z;
    field_count = FIELD_COUNT;
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(long z, int s, char f) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    remove_separators = false;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Segmented::Segmented(long z, int s, char f, bool r) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    remove_separators = r;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Segmented::Segmented(long z, int s, int f) {
    buffer_size = (int)z;
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(long z, int s, int f, bool r) {
    buffer_size = (int)z;
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Segmented::Segmented(char *p, int s, char f) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    strcpy(pattern, p);
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, int s, char f, bool r) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    strcpy(pattern, p);
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, int s, int f) {
    int c;

    buffer_size = UNBROKEN_BUFFER_SIZE;
    strcpy(pattern, p);
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, int s, int f, bool r) {
    int c;

    buffer_size = UNBROKEN_BUFFER_SIZE;
    strcpy(pattern, p);
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, long z, int s, char f) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    strcpy(pattern, p);
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, long z, int s, char f, bool r) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    strcpy(pattern, p);
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, long z, int s, int f) {
    int c;

    buffer_size = (int)z;
    strcpy(pattern, p);
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::Segmented(char *p, long z, int s, int f, bool r) {
    int c;

    buffer_size = (int)z;
    strcpy(pattern, p);
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Segmented::~Segmented() {
    delete[] buffer;
    delete[] combo;

    if(allocated) {
        delete[] selected;
    }

    buffer = NULL;
    combo = NULL;
    selected = NULL;
}

void supplying_bits(char *p, int *field_count) {
    if(*field_count > FIELD_COUNT) {
        *field_count = FIELD_COUNT;
    }

    memset(p, SET, *field_count);
}

void surge_of_set_bits(char *pattern, int field_count, int from, int to) {
// 0011111000000000000, for example
    char *p = pattern;
    int surge_length = to - from + 1;
    int from_1 = from - 1;

    if(surge_length > field_count) {
        surge_length = field_count;
        memset(pattern, SET, surge_length);
        pattern[surge_length] = '\0';
    } else {
        p[field_count] = '\0';
        memset(p, CLEAR, field_count);

        p += from_1;
        memset(p, SET, surge_length);
    }

}
