#include "sutai.h"

extern DOUBLE_UNION ZEROED;

namespace {
    const bool NO_REMOVING = false;
    const int ERROR_CODE = -1;
    const int FIELD_COUNT_0 = 3;
    const int SEPARATOR_0 = ',';
    const long BUFFER_SIZE_0 = 6;
    char BITS_0[] = "111";
}

Standard_input::Standard_input(char *b, long z, int s, int f, int j, int m, int q, int u, bool a, bool c, bool r, bool k, bool t, bool i, bool g, bool v, bool n) {
    buffer_size = (int)z;
    separator = s;
    field_count = f;
    joint = j;
    manager = m;
    quote = q;
    upper_limit = u;
    assume_shift_jis_appears = a;
    combining_character = c;
    remove_separators = r;
    skip_space = k;
    substituted = t;
    add_ID = i;
    carriage_return = g;
    case_sensitive = v;
    descending = n;

    pattern[FIELD_COUNT] = '\0';
    strncpy(pattern, b, FIELD_COUNT);

    char *p = strchr(pattern, CLEAR);
    full_house = (p == NULL) ? true : false;

    try {
        buffer = new char[buffer_size];
    } catch(...) {
        errorHandler("new char[] error-5:", buffer_size, "bytes");
        buffer_size = BLOCK_SIZE;
        buffer = new char[buffer_size];
    }

}

int Standard_input::standard_input_binary_output() {
    using namespace std;

    char *p;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    int buffer_size_1 = buffer_size - 1;
    int dakuten = 0xDE;
    int handakuten = 0xDF;
    int line_count = 0;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        cerr << "fopen() error-9: " << TEMPORARY_BINARY << endl;
        return ERROR_CODE;
    }

    record_size = END + buffer_size;
    if(record_size > BLOCK_SIZE) {
        cerr << "record_size > BLOCK_SIZE error: " << record_size << " bytes" << endl;
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
//                building_double_array = copying_summary;
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer);
                building_double_array(n, d); // summary

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            dakuten = 'P';
            handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer, dakuten, handakuten);
                building_double_array(n, d); // summary

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    }

    delete d;
    fclose(binary_file);
    return line_count;
}

int Standard_input::standard_input_binary_output_adding_ID() {
    using namespace std;

    char *p;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    long z = (long)buffer_size;
    Segmented *d = new Segmented(BITS_0, BUFFER_SIZE_0, SEPARATOR_0, FIELD_COUNT_0, NO_REMOVING);
    int buffer_size_1 = buffer_size - 1;
    int dakuten = 0xDE;
    int handakuten = 0xDF;
    int line_count = 0;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        cerr << "fopen() error-10: " << TEMPORARY_BINARY << endl;
        return ERROR_CODE;
    }

    record_size = END + buffer_size;
    if(record_size > BLOCK_SIZE) {
        cerr << "record_size > BLOCK_SIZE error: " << record_size << " bytes" << endl;
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
//                building_double_array = copying_summary;
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer);
                building_double_array(n, d); // summary

                n->n[LINE_ID] = line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            dakuten = 'P';
            handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { // 0 to 255
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    line_count += 1;
                    if(line_count > upper_limit) {
                        break;
                    }

                    delete d;
                    d = new Segmented(pattern, z, separator, few_fields, remove_separators);
                    d->setting(joint, quote);
                    d->segmented_summary(buffer, dakuten, handakuten);
                    building_double_array(n, d); // summary

                    n->n[LINE_ID] = line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); // details

                    fwrite(n->c, record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                line_count += 1;
                if(line_count > upper_limit) {
                    break;
                }

                delete d;
                d = new Segmented(pattern, z, separator, field_count, remove_separators);
                d->setting(joint, quote);
                d->segmented_summary(buffer, dakuten, handakuten);
                building_double_array(n, d); // summary

                n->n[LINE_ID] = line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); // details

                fwrite(n->c, record_size, 1, binary_file);
            }

        }

    }

    delete d;
    fclose(binary_file);
    return line_count;
}

