#include "kanji_union.h"

int Standard_input::standard_input_output() {
    using namespace std;

    bool kanji = false;
    char *p;
    char a[3] = {0, 0, 0};
    char newLine[3] = {0x0D, 0x0A, 0};
    int c;
    int exit_code = 0;
    unsigned char uc;
    unsigned char firstByte = 0x40;

    SparseEUC *euc = new SparseEUC();
    euc->clear();
    if(! euc->setting(no_searching, specified_directory_has_priority, &whichTable) ) {
        errorHandler("standard_input_output() error:", "euc->setting(no_searching, specified_directory_has_priority, &whichTable)");
        return ERROR_CODE;
    }

    while( cin.getline(buffer, BUFFER_SIZE) ) {
        for(int i = 0; buffer[i]; ++i) {
            uc = (unsigned char)buffer[i];
            c = (int)uc;

            if(kanji) {
                a[0] = (char)firstByte;
                a[1] = buffer[i];
                cout << euc->working( inverted(a) );
                kanji = false;
                continue;
            }

            if(0x81 <= c && c<= 0xFC) {
                if(KANA_KUTEN <= c && c <= KANA_HANDAKUTEN) {
                    cout << euc->working(c);
                    kanji = false;
                } else {
                    firstByte = uc;
                    kanji = true;
                }

            } else {
                cout << uc;
                kanji = false;
            }

        }

        cout << endl;
    }

    delete euc;
    return exit_code;
}
